package adapter

import (
	"context"

	"github.com/uptrace/bun"
)

type CheckerBun struct {
	db *bun.DB
}

func NewCheckerBun(db *bun.DB) *CheckerBun {
	return &CheckerBun{db: db}
}

func (c *CheckerBun) Name() string {
	return "db:ping"
}

func (c *CheckerBun) Check(ctx context.Context) error {
	return c.db.PingContext(ctx)
}
