package adapter_test

import (
	"context"
	"testing"

	"gitea.dwysokinski.me/twhelp/core/internal/adapter"
	"github.com/stretchr/testify/assert"
)

func TestChecker_Name(t *testing.T) {
	t.Parallel()

	assert.Equal(t, "db:ping", adapter.NewCheckerBun(nil).Name())
}

func TestChecker_Check(t *testing.T) {
	t.Parallel()

	if testing.Short() {
		t.Skip("skipping long-running test")
	}

	assert.NoError(t, adapter.NewCheckerBun(newBunDB(t)).Check(context.Background()))
}
